﻿Imports System.Data.OleDb
'Microsoft ADO Ext. 2.8 for DDL and Security の参照追加が必要
Module Module1
    Public MdbPath As String = "C:\Users\user\Documents\SyslogReceive2"
    Public ParentProductName As String = "SyslogReceive2"

    Public SettingIniPathName As String
    Public DebugFlg As Boolean = True 'デバグフラグ
    Public TableNames() As String
    Public MdbLogPathName As String
    Public MdbHostPathName As String
    Public SearchInterval As Integer = 5
    Public FontSize As Single = 12

    'エラーを保存する
    Public Sub ErrorSave(ByVal str As String)
        If DebugFlg Then
            'ファイルに保存
            Try
                Dim ErrorLogPath As String = SettingIniPathName + "\" + Application.ProductName + "_Err" + Now.ToString("yyyyMMdd") + ".txt"
                'Dim ErrorLogPath As String = SettingIniPathName + "\" + Me.ProductName + "_Err" + Now.ToString("yyyyMMdd") + ".txt"
                Dim textFile As System.IO.StreamWriter
                textFile = New System.IO.StreamWriter(ErrorLogPath, True, System.Text.Encoding.Default)
                textFile.WriteLine(Now.ToString + " " + str)
                textFile.Close()
            Catch ex As Exception
            End Try
        End If
    End Sub
    Public Function IPtoInt(ByVal IP As String) As Integer
        Try
            Dim b() As Byte = System.Net.IPAddress.Parse(IP.Trim).GetAddressBytes()
            If b.Length = 4 Then
                Dim bb(3) As Byte
                bb(0) = b(3)
                bb(1) = b(2)
                bb(2) = b(1)
                bb(3) = b(0)
                Return BitConverter.ToInt32(bb, 0)
            Else
                Return 0
            End If
        Catch ex As Exception
            ErrorSave("IPtoInt(" + IP + "): " + ex.ToString)
            Return 0
        End Try

    End Function
    Public Function InttoIP(ByVal IIP As Integer) As String
        Try
            Dim b() As Byte = BitConverter.GetBytes(IIP)
            Dim bb(3) As Byte
            bb(0) = b(3)
            bb(1) = b(2)
            bb(2) = b(1)
            bb(3) = b(0)
            Dim ip As System.Net.IPAddress
            ip = New System.Net.IPAddress(bb)
            Return ip.ToString
        Catch ex As Exception
            ErrorSave("InttoIP(" + IIP.ToString + "): " + ex.ToString)
            Return ""
        End Try
    End Function

    Public Function MdbGetTableNames(ByVal file_name As String) As Boolean
        If file_name = "" Then Return False
        Dim oConn As New OleDbConnection()
        Try
            'DB接続文字列の設定
            oConn.ConnectionString = _
              "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + file_name
            'ＤＢ接続
            oConn.Open()

            Dim schemaTable As DataTable
            schemaTable = oConn.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, _
                          New Object() {Nothing, Nothing, Nothing, "TABLE"})
            'テーブル読込
            If schemaTable.Rows.Count > 0 Then
                ReDim TableNames(schemaTable.Rows.Count - 1)
                Dim i As Integer
                For i = 0 To schemaTable.Rows.Count - 1
                    TableNames(i) = schemaTable.Rows(i)("TABLE_NAME").ToString
                Next i
            End If

            MdbGetTableNames = True
        Catch oExcept As Exception
            '例外が発生した時の処理
            'MsgBox(oExcept.ToString)
            MdbGetTableNames = False

        Finally
            'ＤＢクローズ
            If Not oConn Is Nothing Then
                oConn.Close()
            End If
        End Try

    End Function

    Public Function MdbExecuteNonQuery(ByVal FileName As String, ByVal Str As String) As Boolean
        Dim oConn As New OleDbConnection()
        Dim oCommand As New OleDbCommand()

        Try
            oConn = New OleDbConnection()
            'DB接続文字列の設定
            oConn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + _
            FileName

            'コネクションの設定
            oCommand.Connection = oConn

            'ＤＢ接続を開く
            oConn.Open()

            'SQL文の設定
            oCommand.CommandText = Str

            oCommand.ExecuteNonQuery()
            '正常リターン
            MdbExecuteNonQuery = True

        Catch oExcept As Exception
            '例外が発生した時の処理
            MsgBox(oExcept.ToString)
            ErrorSave("MdbExecuteNonQuery(" + Str + "): " + oExcept.ToString)
            MdbExecuteNonQuery = False

        Finally
            'ＤＢ接続を閉じる
            If Not oConn Is Nothing Then
                oConn.Close()
            End If

        End Try




    End Function

    Public Function MdbDataAdapterFill(ByVal FileName As String, ByVal Str As String, ByVal Dt As DataTable) As Boolean
        Dim ConString As String = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + _
        FileName
        MdbDataAdapterFill = True
        Try
            Using da As New OleDbDataAdapter(Str, ConString)
                da.Fill(Dt)
            End Using

        Catch ex As Exception
            MdbDataAdapterFill = False
            MsgBox(ex.ToString, , "エラー")
            ErrorSave("MdbDataAdapterFill(" + Str + "): " + ex.ToString)
        End Try

    End Function

End Module
